This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
Fix a Storable test to work in 5.8.9-
[perl5.git] / dist / Storable / t / restrict.t
index 20e8165..65dac6f 100644 (file)
@@ -8,6 +8,7 @@
 
 sub BEGIN {
     unshift @INC, 't';
+    unshift @INC, 't/compat' if $] < 5.006002;
     if ($ENV{PERL_CORE}){
         require Config;
         if ($Config::Config{'extensions'} !~ /\bStorable\b/) {
@@ -19,7 +20,7 @@ sub BEGIN {
            print "1..0 # Skip: No Hash::Util pre 5.005\n";
            exit 0;
            # And doing this seems on 5.004 seems to create bogus warnings about
-           # unitialized variables, or coredumps in Perl_pp_padsv
+           # uninitialized variables, or coredumps in Perl_pp_padsv
        } elsif (!eval "require Hash::Util") {
             if ($@ =~ /Can\'t locate Hash\/Util\.pm in \@INC/s) {
                 print "1..0 # Skip: No Hash::Util:\n";
@@ -34,8 +35,8 @@ sub BEGIN {
 
 
 use Storable qw(dclone freeze thaw);
-use Hash::Util qw(lock_hash unlock_value);
-use Test::More tests => 100;
+use Hash::Util qw(lock_hash unlock_value lock_keys);
+use Test::More tests => 104;
 
 my %hash = (question => '?', answer => 42, extra => 'junk', undef => undef);
 lock_hash %hash;
@@ -90,7 +91,7 @@ sub testit {
 
 for $Storable::canonical (0, 1) {
   for my $cloner (\&dclone, \&freeze_thaw) {
-    note("\$Storable::canonical = $Storable::canonical");
+    print "# \$Storable::canonical = $Storable::canonical\n";
     testit (\%hash, $cloner);
     my $object = \%hash;
     # bless {}, "Restrict_Test";
@@ -109,5 +110,11 @@ for $Storable::canonical (0, 1) {
       eval { $copy->{$k} = undef } ;
       is($@, '', "Can assign to reserved key '$k'?");
     }
+
+    my %hv;
+    $hv{a} = __PACKAGE__;
+    lock_keys %hv;
+    my $hv2 = &$cloner(\%hv);
+    ok eval { $$hv2{a} = 70 }, 'COWs do not become read-only';
   }
 }